;;; Micelaneous
;;;
;;; Define algumas opcoes padrao do Emacs

;; mostra hora
(display-time)

;; Tira o toolbar
(tool-bar-mode nil)

;; Tira o menu de cima
(menu-bar-mode nil)
;(menu-bar-mode  (if window-system 1 -1))

;; controle de versoes
(setq version-control t)
(setq kept-old-versions 0)
(setq kept-new-versions 2)
(setq trim-versions-without-asking t)
(setq backup-by-copying t)

;; escrever linha no final "nao"
(setq next-line-add-newlines nil)

;; global-font-lock-mode
(global-font-lock-mode t)

;; mostra a coluna
(column-number-mode 1)

;; yes = y , no = n :)
(fset 'yes-or-no-p 'y-or-n-p)

;; define minha fonte default
(set-default-font "fixed")

;; titulo
(setq frame-title-format (list "%b - GNU Emacs " emacs-version))
(setq icon-title-format frame-title-format)

;; rola uma linha por vez
(setq scroll-step 1)

;; Desliga a mensagem de entrada
(setq inhibit-startup-message t)

;; ispell
(load-library "ispell")
(setq ispell-dictionary-alist
      (cons '("br" "[A-Za-z\300\301\302\303\307\311\312\315\323\324\325\332\334\340\341\342\343\347\351\352\355\364\365\372\374]" "[^A-Za-z\300\301\302\303\307\311\312\315\323\324\325\332\334\340\341\342\343\347\351\352\355\364\365\372\374]" "[---]" nil ("-B" "-d" "br") "~tex" iso-latin-1)
	    ispell-dictionary-alist))
(setq ispell-dictionary "br")

;; desliga o blinking do cursor
(blink-cursor-mode nil)
