;;; modes
;;;
;;; Define o modo de cara tipo de arquivo e configura algumas coisas

;; modo padrao
(setq default-major-mode 'text-mode)

;; Modo texto
(add-hook 'text-mode-hook
	  '(lambda ()	     
	     ;; quebra de linha na coluna 72
	     (auto-fill-mode)
	     (setq default-fill-column 72)	     
	     ;; acentos
	     (iso-accents-mode t)
	     (iso-accents-customize "portuguese")))

;; Configuracoes para o c-mode
(defun rw-c-mode ()
  "Minhas configuracoes padrao para usar com o c-mode"
  (interactive)
  (c-mode)
  (c-set-style "K&R")
  (setq c-basic-offset 8))

; C-c C-c = comando para compilar
(setq c-mode-hook '(lambda () 
		     (define-key c-mode-map "\^C\^C" 'compile)))

;; define o comando pra compilar c-mode
(setq compile-command "gcc -Wall -g -o ")

;; tipos de arquivos e seus respectivos modos
(setq auto-mode-alist
      (cons '("\\.c$" . rw-c-mode)
	    (cons '("\\.h$" . rw-c-mode)
		  (cons '("\\.pl$" . perl-mode)
			(cons '("\\.cgi$" . rw-c-mode)			
			      (cons '("Makefile$" . makefile-mode)
				    (cons '("\\.txt$" . text-mode)
					  (cons '("\\.htm\\$" . html-mode)
						(cons '("\\.html\\$" . html-mode)
						      (cons '("\\.php$" . php-mode)
							    (cons '("\\.phtml$" . php-mode)
								  (cons '("\\.php3$" . php-mode)
									(cons '("\\.php4$" . php-mode)
									      (cons '("\\TODO$" . todo-mode)
										    auto-mode-alist))))))))))))))
