; license-buffer-under-gpl.el
; 
; Copyright 1999 Colin Walters <levanti@verbum.org>
; All rights reserved.
; 
; This program is free software; you can redistribute it and/or modify 
; it under the terms of the GNU General Public License as published by 
; the Free Software Foundation; either version 2 of the License, or 
; (at your option) any later version.

;; please note, i know this has lines much longer than 80 characters,
;; but I run framebuffer console at 1024x768 and so it doesn't bother
;; me :)

;; on a secondary note, I am just learning lisp as I write this, so
;; I'm not responsible if your computer melts.

(defun license-buffer-under-gpl ()
  "This function inserts a GPL header into the current buffer."
  (interactive)
  (let ((user-full-name (or user-full-name 
			    (user-full-name)
			    (user-login-name)
			    "Anonymous"))
	(user-mail-address (or user-mail-address
			       (concat (user-login-name)
				       "@"
				       mail-host-address)))
	(gpl-text 
	 (cons (buffer-name)
	       (cons "" (cons 
			 (concat "Copyright "
				 (substring (current-time-string) 20) 
				 ;; yes, this does have a year 10,000 problem.
				 ;; hopefully, by then you will be using a hyperadvanced
				 ;; AI to assist you in programming, and it will
				 ;; probably be better than this lisp hack.
				 ;; ...
				 ;; M-x hyper-advanced-ai-mode :)
				 " " user-full-name " <" user-mail-address ">") 
			 (cons "All rights reserved." 
			       '(
				 ""
				 "This program is free software; you can redistribute it and/or modify "
				 "it under the terms of the GNU General Public License as published by "
				 "the Free Software Foundation; either version 2 of the License, or "
				 "(at your option) any later version."
				 ))))))
	(comment-start (or comment-start ""))
	(comment-end (or comment-end "")))
    (save-excursion
      ;; yes, this is a gross hack, but it looks much prettier for C files
      (if (string= mode-name "C")
	  (progn
	    (goto-char (point-min))
	    (insert-string "/*\n") 
	    (let ((gpl-text-insert-count 0)
		  (gpl-text-length (length gpl-text)))
	      (while (< gpl-text-insert-count gpl-text-length)
		(progn
		  (insert-string 
		   (concat " " (car (nthcdr gpl-text-insert-count gpl-text)) "\n"))
		  (setq gpl-text-insert-count (1+ gpl-text-insert-count))))
	      (insert-string "*/\n\n")))
	;; this is the general case
	(progn 
	  (goto-char (point-min))
	  ;; we should skip shebang lines, to help our our friend UNIX
	  (if (>= (buffer-size) 3)
	      (if (string= (buffer-substring 1 3) "#!")
		  (progn (goto-line 2)
			 (message "license-buffer-under-gpl: skipping #! line."))))
	  ;; some modes include " " in their comment-start - we don't like that
	  (if (>= (length comment-start) 2)
	      (if (string= (substring comment-start -1 (length comment-start)) " ")
		  (setq comment-start (substring comment-start 0 (- (length comment-start) 1)))))
	  (let ((gpl-text-insert-count 0)
		(gpl-text-length (length gpl-text))
		(comment-start (concat comment-start " "))
		(comment-end (concat comment-end "\n")))
	    (while (< gpl-text-insert-count gpl-text-length)
	      (progn
		(insert-string 
		 (concat comment-start (car (nthcdr gpl-text-insert-count gpl-text)) comment-end))
		(setq gpl-text-insert-count (1+ gpl-text-insert-count))))
	    (insert-string "\n")))))))